/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlySignerAccount, ReadonlyUint8Array, TransactionSigner, WritableAccount } from '@solana/web3.js';
import { SPL_ACCOUNT_COMPRESSION_PROGRAM_ADDRESS } from '../programs';
export type TransferAuthorityInstruction<TProgram extends string = typeof SPL_ACCOUNT_COMPRESSION_PROGRAM_ADDRESS, TAccountMerkleTree extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountMerkleTree extends string ? WritableAccount<TAccountMerkleTree> : TAccountMerkleTree,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    ...TRemainingAccounts
]>;
export type TransferAuthorityInstructionData = {
    discriminator: ReadonlyUint8Array;
    newAuthority: Address;
};
export type TransferAuthorityInstructionDataArgs = {
    newAuthority: Address;
};
export declare function getTransferAuthorityInstructionDataEncoder(): Encoder<TransferAuthorityInstructionDataArgs>;
export declare function getTransferAuthorityInstructionDataDecoder(): Decoder<TransferAuthorityInstructionData>;
export declare function getTransferAuthorityInstructionDataCodec(): Codec<TransferAuthorityInstructionDataArgs, TransferAuthorityInstructionData>;
export type TransferAuthorityInput<TAccountMerkleTree extends string = string, TAccountAuthority extends string = string> = {
    merkleTree: Address<TAccountMerkleTree>;
    /**
     * Authority that controls write-access to the tree
     * Typically a program, e.g., the Bubblegum contract validates that leaves are valid NFTs.
     */
    authority: TransactionSigner<TAccountAuthority>;
    newAuthority: TransferAuthorityInstructionDataArgs['newAuthority'];
};
export declare function getTransferAuthorityInstruction<TAccountMerkleTree extends string, TAccountAuthority extends string>(input: TransferAuthorityInput<TAccountMerkleTree, TAccountAuthority>): TransferAuthorityInstruction<typeof SPL_ACCOUNT_COMPRESSION_PROGRAM_ADDRESS, TAccountMerkleTree, TAccountAuthority>;
export type ParsedTransferAuthorityInstruction<TProgram extends string = typeof SPL_ACCOUNT_COMPRESSION_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        merkleTree: TAccountMetas[0];
        /**
         * Authority that controls write-access to the tree
         * Typically a program, e.g., the Bubblegum contract validates that leaves are valid NFTs.
         */
        authority: TAccountMetas[1];
    };
    data: TransferAuthorityInstructionData;
};
export declare function parseTransferAuthorityInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedTransferAuthorityInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=transferAuthority.d.ts.map