export type TreeNode = {
    id: number;
    left: TreeNode | undefined;
    level: number;
    node: Buffer;
    parent: TreeNode | undefined;
    right: TreeNode | undefined;
};
export type MerkleTreeProof = {
    leaf: Buffer;
    leafIndex: number;
    proof: Buffer[];
    root: Buffer;
};
export declare class MerkleTree {
    leaves: TreeNode[];
    root: Buffer;
    depth: number;
    constructor(leaves: Buffer[]);
    getProof(leafIndex: number, minimizeProofHeight?: boolean, treeHeight?: number, verbose?: boolean): {
        proof: Buffer[];
    };
}
export declare function sparseMerkleTreeFromLeaves(leaves: Buffer[], depth: number): MerkleTree;
//# sourceMappingURL=merkleTree.d.ts.map