import { Address, KeyPairSigner } from "@solana/web3.js";
import { Creator, MetadataArgs } from "../generated";
import { Client } from "@tensor-foundation/test-helpers";
import { MerkleTree } from ".";
export type DepthSizePair = {
    maxDepth: number;
    maxBufferSize: number;
};
export type CompressedSetupReturn = {
    collectionMint: Address;
    merkleTree: Address;
    memTree: MerkleTree;
    root: Uint8Array;
    meta: MetadataArgs;
    leaf: Buffer;
    assetId: Address;
    proof: Address[];
};
export declare function setupSingleVerifiedCNFT({ client, cNftOwner, payer, mintAuthority, collectionOwner, treeOwner, creatorKeypair, creator, treeDepthSize, canopyDepth, leafIndex, }: {
    client: Client;
    cNftOwner: Address;
    payer?: KeyPairSigner;
    mintAuthority?: KeyPairSigner;
    collectionOwner?: KeyPairSigner;
    treeOwner?: KeyPairSigner;
    creatorKeypair: KeyPairSigner;
    creator: Creator;
    treeDepthSize?: DepthSizePair;
    canopyDepth?: number;
    leafIndex?: number;
}): Promise<{
    collectionMint: Address;
    merkleTree: Address;
    memTree: MerkleTree;
    root: Buffer;
    meta: MetadataArgs;
    leaf: Buffer;
    assetId: Address<string>;
    proof: Address<string>[];
}>;
//# sourceMappingURL=setup.d.ts.map