/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, ReadonlySignerAccount, ReadonlyUint8Array, TransactionSigner, WritableAccount } from '@solana/web3.js';
import { BUBBLEGUM_PROGRAM_ADDRESS } from '../programs';
export type DelegateInstruction<TProgram extends string = typeof BUBBLEGUM_PROGRAM_ADDRESS, TAccountTreeAuthority extends string | IAccountMeta<string> = string, TAccountLeafOwner extends string | IAccountMeta<string> = string, TAccountPreviousLeafDelegate extends string | IAccountMeta<string> = string, TAccountNewLeafDelegate extends string | IAccountMeta<string> = string, TAccountMerkleTree extends string | IAccountMeta<string> = string, TAccountLogWrapper extends string | IAccountMeta<string> = string, TAccountCompressionProgram extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountTreeAuthority extends string ? ReadonlyAccount<TAccountTreeAuthority> : TAccountTreeAuthority,
    TAccountLeafOwner extends string ? ReadonlySignerAccount<TAccountLeafOwner> & IAccountSignerMeta<TAccountLeafOwner> : TAccountLeafOwner,
    TAccountPreviousLeafDelegate extends string ? ReadonlyAccount<TAccountPreviousLeafDelegate> : TAccountPreviousLeafDelegate,
    TAccountNewLeafDelegate extends string ? ReadonlyAccount<TAccountNewLeafDelegate> : TAccountNewLeafDelegate,
    TAccountMerkleTree extends string ? WritableAccount<TAccountMerkleTree> : TAccountMerkleTree,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    TAccountCompressionProgram extends string ? ReadonlyAccount<TAccountCompressionProgram> : TAccountCompressionProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type DelegateInstructionData = {
    discriminator: ReadonlyUint8Array;
    root: ReadonlyUint8Array;
    dataHash: ReadonlyUint8Array;
    creatorHash: ReadonlyUint8Array;
    nonce: bigint;
    index: number;
};
export type DelegateInstructionDataArgs = {
    root: ReadonlyUint8Array;
    dataHash: ReadonlyUint8Array;
    creatorHash: ReadonlyUint8Array;
    nonce: number | bigint;
    index: number;
};
export declare function getDelegateInstructionDataEncoder(): Encoder<DelegateInstructionDataArgs>;
export declare function getDelegateInstructionDataDecoder(): Decoder<DelegateInstructionData>;
export declare function getDelegateInstructionDataCodec(): Codec<DelegateInstructionDataArgs, DelegateInstructionData>;
export type DelegateInput<TAccountTreeAuthority extends string = string, TAccountLeafOwner extends string = string, TAccountPreviousLeafDelegate extends string = string, TAccountNewLeafDelegate extends string = string, TAccountMerkleTree extends string = string, TAccountLogWrapper extends string = string, TAccountCompressionProgram extends string = string, TAccountSystemProgram extends string = string> = {
    treeAuthority: Address<TAccountTreeAuthority>;
    leafOwner: TransactionSigner<TAccountLeafOwner>;
    previousLeafDelegate: Address<TAccountPreviousLeafDelegate>;
    newLeafDelegate: Address<TAccountNewLeafDelegate>;
    merkleTree: Address<TAccountMerkleTree>;
    logWrapper: Address<TAccountLogWrapper>;
    compressionProgram: Address<TAccountCompressionProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    root: DelegateInstructionDataArgs['root'];
    dataHash: DelegateInstructionDataArgs['dataHash'];
    creatorHash: DelegateInstructionDataArgs['creatorHash'];
    nonce: DelegateInstructionDataArgs['nonce'];
    index: DelegateInstructionDataArgs['index'];
};
export declare function getDelegateInstruction<TAccountTreeAuthority extends string, TAccountLeafOwner extends string, TAccountPreviousLeafDelegate extends string, TAccountNewLeafDelegate extends string, TAccountMerkleTree extends string, TAccountLogWrapper extends string, TAccountCompressionProgram extends string, TAccountSystemProgram extends string>(input: DelegateInput<TAccountTreeAuthority, TAccountLeafOwner, TAccountPreviousLeafDelegate, TAccountNewLeafDelegate, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram>): DelegateInstruction<typeof BUBBLEGUM_PROGRAM_ADDRESS, TAccountTreeAuthority, TAccountLeafOwner, TAccountPreviousLeafDelegate, TAccountNewLeafDelegate, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram>;
export type ParsedDelegateInstruction<TProgram extends string = typeof BUBBLEGUM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        treeAuthority: TAccountMetas[0];
        leafOwner: TAccountMetas[1];
        previousLeafDelegate: TAccountMetas[2];
        newLeafDelegate: TAccountMetas[3];
        merkleTree: TAccountMetas[4];
        logWrapper: TAccountMetas[5];
        compressionProgram: TAccountMetas[6];
        systemProgram: TAccountMetas[7];
    };
    data: DelegateInstructionData;
};
export declare function parseDelegateInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedDelegateInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=delegate.d.ts.map