/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, ReadonlyUint8Array, WritableAccount } from '@solana/web3.js';
import { BUBBLEGUM_PROGRAM_ADDRESS } from '../programs';
export type TransferInstruction<TProgram extends string = typeof BUBBLEGUM_PROGRAM_ADDRESS, TAccountTreeAuthority extends string | IAccountMeta<string> = string, TAccountLeafOwner extends string | IAccountMeta<string> = string, TAccountLeafDelegate extends string | IAccountMeta<string> = string, TAccountNewLeafOwner extends string | IAccountMeta<string> = string, TAccountMerkleTree extends string | IAccountMeta<string> = string, TAccountLogWrapper extends string | IAccountMeta<string> = string, TAccountCompressionProgram extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountTreeAuthority extends string ? ReadonlyAccount<TAccountTreeAuthority> : TAccountTreeAuthority,
    TAccountLeafOwner extends string ? ReadonlyAccount<TAccountLeafOwner> : TAccountLeafOwner,
    TAccountLeafDelegate extends string ? ReadonlyAccount<TAccountLeafDelegate> : TAccountLeafDelegate,
    TAccountNewLeafOwner extends string ? ReadonlyAccount<TAccountNewLeafOwner> : TAccountNewLeafOwner,
    TAccountMerkleTree extends string ? WritableAccount<TAccountMerkleTree> : TAccountMerkleTree,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    TAccountCompressionProgram extends string ? ReadonlyAccount<TAccountCompressionProgram> : TAccountCompressionProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type TransferInstructionData = {
    discriminator: ReadonlyUint8Array;
    root: ReadonlyUint8Array;
    dataHash: ReadonlyUint8Array;
    creatorHash: ReadonlyUint8Array;
    nonce: bigint;
    index: number;
};
export type TransferInstructionDataArgs = {
    root: ReadonlyUint8Array;
    dataHash: ReadonlyUint8Array;
    creatorHash: ReadonlyUint8Array;
    nonce: number | bigint;
    index: number;
};
export declare function getTransferInstructionDataEncoder(): Encoder<TransferInstructionDataArgs>;
export declare function getTransferInstructionDataDecoder(): Decoder<TransferInstructionData>;
export declare function getTransferInstructionDataCodec(): Codec<TransferInstructionDataArgs, TransferInstructionData>;
export type TransferInput<TAccountTreeAuthority extends string = string, TAccountLeafOwner extends string = string, TAccountLeafDelegate extends string = string, TAccountNewLeafOwner extends string = string, TAccountMerkleTree extends string = string, TAccountLogWrapper extends string = string, TAccountCompressionProgram extends string = string, TAccountSystemProgram extends string = string> = {
    treeAuthority: Address<TAccountTreeAuthority>;
    leafOwner: Address<TAccountLeafOwner>;
    leafDelegate: Address<TAccountLeafDelegate>;
    newLeafOwner: Address<TAccountNewLeafOwner>;
    merkleTree: Address<TAccountMerkleTree>;
    logWrapper: Address<TAccountLogWrapper>;
    compressionProgram: Address<TAccountCompressionProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    root: TransferInstructionDataArgs['root'];
    dataHash: TransferInstructionDataArgs['dataHash'];
    creatorHash: TransferInstructionDataArgs['creatorHash'];
    nonce: TransferInstructionDataArgs['nonce'];
    index: TransferInstructionDataArgs['index'];
};
export declare function getTransferInstruction<TAccountTreeAuthority extends string, TAccountLeafOwner extends string, TAccountLeafDelegate extends string, TAccountNewLeafOwner extends string, TAccountMerkleTree extends string, TAccountLogWrapper extends string, TAccountCompressionProgram extends string, TAccountSystemProgram extends string>(input: TransferInput<TAccountTreeAuthority, TAccountLeafOwner, TAccountLeafDelegate, TAccountNewLeafOwner, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram>): TransferInstruction<typeof BUBBLEGUM_PROGRAM_ADDRESS, TAccountTreeAuthority, TAccountLeafOwner, TAccountLeafDelegate, TAccountNewLeafOwner, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram>;
export type ParsedTransferInstruction<TProgram extends string = typeof BUBBLEGUM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        treeAuthority: TAccountMetas[0];
        leafOwner: TAccountMetas[1];
        leafDelegate: TAccountMetas[2];
        newLeafOwner: TAccountMetas[3];
        merkleTree: TAccountMetas[4];
        logWrapper: TAccountMetas[5];
        compressionProgram: TAccountMetas[6];
        systemProgram: TAccountMetas[7];
    };
    data: TransferInstructionData;
};
export declare function parseTransferInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedTransferInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=transfer.d.ts.map