/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, Option, OptionOrNullable, ReadonlyAccount, ReadonlySignerAccount, ReadonlyUint8Array, TransactionSigner, WritableAccount } from '@solana/web3.js';
import { BUBBLEGUM_PROGRAM_ADDRESS } from '../programs';
import { Creator, CreatorArgs, MetadataArgs, MetadataArgsArgs } from '../types';
export type UpdateMetadataInstruction<TProgram extends string = typeof BUBBLEGUM_PROGRAM_ADDRESS, TAccountTreeAuthority extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountCollectionMint extends string | IAccountMeta<string> = string, TAccountCollectionMetadata extends string | IAccountMeta<string> = string, TAccountCollectionAuthorityRecordPda extends string | IAccountMeta<string> = string, TAccountLeafOwner extends string | IAccountMeta<string> = string, TAccountLeafDelegate extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountMerkleTree extends string | IAccountMeta<string> = string, TAccountLogWrapper extends string | IAccountMeta<string> = string, TAccountCompressionProgram extends string | IAccountMeta<string> = string, TAccountTokenMetadataProgram extends string | IAccountMeta<string> = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountTreeAuthority extends string ? ReadonlyAccount<TAccountTreeAuthority> : TAccountTreeAuthority,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountCollectionMint extends string ? ReadonlyAccount<TAccountCollectionMint> : TAccountCollectionMint,
    TAccountCollectionMetadata extends string ? ReadonlyAccount<TAccountCollectionMetadata> : TAccountCollectionMetadata,
    TAccountCollectionAuthorityRecordPda extends string ? ReadonlyAccount<TAccountCollectionAuthorityRecordPda> : TAccountCollectionAuthorityRecordPda,
    TAccountLeafOwner extends string ? ReadonlyAccount<TAccountLeafOwner> : TAccountLeafOwner,
    TAccountLeafDelegate extends string ? ReadonlyAccount<TAccountLeafDelegate> : TAccountLeafDelegate,
    TAccountPayer extends string ? ReadonlySignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountMerkleTree extends string ? WritableAccount<TAccountMerkleTree> : TAccountMerkleTree,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    TAccountCompressionProgram extends string ? ReadonlyAccount<TAccountCompressionProgram> : TAccountCompressionProgram,
    TAccountTokenMetadataProgram extends string ? ReadonlyAccount<TAccountTokenMetadataProgram> : TAccountTokenMetadataProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type UpdateMetadataInstructionData = {
    discriminator: ReadonlyUint8Array;
    root: ReadonlyUint8Array;
    nonce: bigint;
    index: number;
    currentMetadata: MetadataArgs;
    name: Option<string>;
    symbol: Option<string>;
    uri: Option<string>;
    creators: Option<Array<Creator>>;
    sellerFeeBasisPoints: Option<number>;
    primarySaleHappened: Option<boolean>;
    isMutable: Option<boolean>;
};
export type UpdateMetadataInstructionDataArgs = {
    root: ReadonlyUint8Array;
    nonce: number | bigint;
    index: number;
    currentMetadata: MetadataArgsArgs;
    name: OptionOrNullable<string>;
    symbol: OptionOrNullable<string>;
    uri: OptionOrNullable<string>;
    creators: OptionOrNullable<Array<CreatorArgs>>;
    sellerFeeBasisPoints: OptionOrNullable<number>;
    primarySaleHappened: OptionOrNullable<boolean>;
    isMutable: OptionOrNullable<boolean>;
};
export declare function getUpdateMetadataInstructionDataEncoder(): Encoder<UpdateMetadataInstructionDataArgs>;
export declare function getUpdateMetadataInstructionDataDecoder(): Decoder<UpdateMetadataInstructionData>;
export declare function getUpdateMetadataInstructionDataCodec(): Codec<UpdateMetadataInstructionDataArgs, UpdateMetadataInstructionData>;
export type UpdateMetadataInput<TAccountTreeAuthority extends string = string, TAccountAuthority extends string = string, TAccountCollectionMint extends string = string, TAccountCollectionMetadata extends string = string, TAccountCollectionAuthorityRecordPda extends string = string, TAccountLeafOwner extends string = string, TAccountLeafDelegate extends string = string, TAccountPayer extends string = string, TAccountMerkleTree extends string = string, TAccountLogWrapper extends string = string, TAccountCompressionProgram extends string = string, TAccountTokenMetadataProgram extends string = string, TAccountSystemProgram extends string = string> = {
    treeAuthority: Address<TAccountTreeAuthority>;
    /**
     * Either collection authority or tree owner/delegate, depending
     * on whether the item is in a verified collection
     */
    authority: TransactionSigner<TAccountAuthority>;
    /** Used when item is in a verified collection */
    collectionMint?: Address<TAccountCollectionMint>;
    /** Used when item is in a verified collection */
    collectionMetadata?: Address<TAccountCollectionMetadata>;
    collectionAuthorityRecordPda?: Address<TAccountCollectionAuthorityRecordPda>;
    leafOwner: Address<TAccountLeafOwner>;
    leafDelegate: Address<TAccountLeafDelegate>;
    payer: TransactionSigner<TAccountPayer>;
    merkleTree: Address<TAccountMerkleTree>;
    logWrapper: Address<TAccountLogWrapper>;
    compressionProgram: Address<TAccountCompressionProgram>;
    tokenMetadataProgram?: Address<TAccountTokenMetadataProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    root: UpdateMetadataInstructionDataArgs['root'];
    nonce: UpdateMetadataInstructionDataArgs['nonce'];
    index: UpdateMetadataInstructionDataArgs['index'];
    currentMetadata: UpdateMetadataInstructionDataArgs['currentMetadata'];
    name: UpdateMetadataInstructionDataArgs['name'];
    symbol: UpdateMetadataInstructionDataArgs['symbol'];
    uri: UpdateMetadataInstructionDataArgs['uri'];
    creators: UpdateMetadataInstructionDataArgs['creators'];
    sellerFeeBasisPoints: UpdateMetadataInstructionDataArgs['sellerFeeBasisPoints'];
    primarySaleHappened: UpdateMetadataInstructionDataArgs['primarySaleHappened'];
    isMutable: UpdateMetadataInstructionDataArgs['isMutable'];
};
export declare function getUpdateMetadataInstruction<TAccountTreeAuthority extends string, TAccountAuthority extends string, TAccountCollectionMint extends string, TAccountCollectionMetadata extends string, TAccountCollectionAuthorityRecordPda extends string, TAccountLeafOwner extends string, TAccountLeafDelegate extends string, TAccountPayer extends string, TAccountMerkleTree extends string, TAccountLogWrapper extends string, TAccountCompressionProgram extends string, TAccountTokenMetadataProgram extends string, TAccountSystemProgram extends string>(input: UpdateMetadataInput<TAccountTreeAuthority, TAccountAuthority, TAccountCollectionMint, TAccountCollectionMetadata, TAccountCollectionAuthorityRecordPda, TAccountLeafOwner, TAccountLeafDelegate, TAccountPayer, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountTokenMetadataProgram, TAccountSystemProgram>): UpdateMetadataInstruction<typeof BUBBLEGUM_PROGRAM_ADDRESS, TAccountTreeAuthority, TAccountAuthority, TAccountCollectionMint, TAccountCollectionMetadata, TAccountCollectionAuthorityRecordPda, TAccountLeafOwner, TAccountLeafDelegate, TAccountPayer, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountTokenMetadataProgram, TAccountSystemProgram>;
export type ParsedUpdateMetadataInstruction<TProgram extends string = typeof BUBBLEGUM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        treeAuthority: TAccountMetas[0];
        /**
         * Either collection authority or tree owner/delegate, depending
         * on whether the item is in a verified collection
         */
        authority: TAccountMetas[1];
        /** Used when item is in a verified collection */
        collectionMint?: TAccountMetas[2] | undefined;
        /** Used when item is in a verified collection */
        collectionMetadata?: TAccountMetas[3] | undefined;
        collectionAuthorityRecordPda?: TAccountMetas[4] | undefined;
        leafOwner: TAccountMetas[5];
        leafDelegate: TAccountMetas[6];
        payer: TAccountMetas[7];
        merkleTree: TAccountMetas[8];
        logWrapper: TAccountMetas[9];
        compressionProgram: TAccountMetas[10];
        tokenMetadataProgram: TAccountMetas[11];
        systemProgram: TAccountMetas[12];
    };
    data: UpdateMetadataInstructionData;
};
export declare function parseUpdateMetadataInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedUpdateMetadataInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=updateMetadata.d.ts.map