/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, ReadonlySignerAccount, ReadonlyUint8Array, TransactionSigner, WritableAccount } from '@solana/web3.js';
import { BUBBLEGUM_PROGRAM_ADDRESS } from '../programs';
import { MetadataArgs, MetadataArgsArgs } from '../types';
export type VerifyCollectionInstruction<TProgram extends string = typeof BUBBLEGUM_PROGRAM_ADDRESS, TAccountTreeAuthority extends string | IAccountMeta<string> = string, TAccountLeafOwner extends string | IAccountMeta<string> = string, TAccountLeafDelegate extends string | IAccountMeta<string> = string, TAccountMerkleTree extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountTreeDelegate extends string | IAccountMeta<string> = string, TAccountCollectionAuthority extends string | IAccountMeta<string> = string, TAccountCollectionAuthorityRecordPda extends string | IAccountMeta<string> = string, TAccountCollectionMint extends string | IAccountMeta<string> = string, TAccountCollectionMetadata extends string | IAccountMeta<string> = string, TAccountEditionAccount extends string | IAccountMeta<string> = string, TAccountBubblegumSigner extends string | IAccountMeta<string> = string, TAccountLogWrapper extends string | IAccountMeta<string> = string, TAccountCompressionProgram extends string | IAccountMeta<string> = string, TAccountTokenMetadataProgram extends string | IAccountMeta<string> = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountTreeAuthority extends string ? ReadonlyAccount<TAccountTreeAuthority> : TAccountTreeAuthority,
    TAccountLeafOwner extends string ? ReadonlyAccount<TAccountLeafOwner> : TAccountLeafOwner,
    TAccountLeafDelegate extends string ? ReadonlyAccount<TAccountLeafDelegate> : TAccountLeafDelegate,
    TAccountMerkleTree extends string ? WritableAccount<TAccountMerkleTree> : TAccountMerkleTree,
    TAccountPayer extends string ? ReadonlySignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountTreeDelegate extends string ? ReadonlyAccount<TAccountTreeDelegate> : TAccountTreeDelegate,
    TAccountCollectionAuthority extends string ? ReadonlySignerAccount<TAccountCollectionAuthority> & IAccountSignerMeta<TAccountCollectionAuthority> : TAccountCollectionAuthority,
    TAccountCollectionAuthorityRecordPda extends string ? ReadonlyAccount<TAccountCollectionAuthorityRecordPda> : TAccountCollectionAuthorityRecordPda,
    TAccountCollectionMint extends string ? ReadonlyAccount<TAccountCollectionMint> : TAccountCollectionMint,
    TAccountCollectionMetadata extends string ? WritableAccount<TAccountCollectionMetadata> : TAccountCollectionMetadata,
    TAccountEditionAccount extends string ? ReadonlyAccount<TAccountEditionAccount> : TAccountEditionAccount,
    TAccountBubblegumSigner extends string ? ReadonlyAccount<TAccountBubblegumSigner> : TAccountBubblegumSigner,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    TAccountCompressionProgram extends string ? ReadonlyAccount<TAccountCompressionProgram> : TAccountCompressionProgram,
    TAccountTokenMetadataProgram extends string ? ReadonlyAccount<TAccountTokenMetadataProgram> : TAccountTokenMetadataProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type VerifyCollectionInstructionData = {
    discriminator: ReadonlyUint8Array;
    root: ReadonlyUint8Array;
    dataHash: ReadonlyUint8Array;
    creatorHash: ReadonlyUint8Array;
    nonce: bigint;
    index: number;
    message: MetadataArgs;
};
export type VerifyCollectionInstructionDataArgs = {
    root: ReadonlyUint8Array;
    dataHash: ReadonlyUint8Array;
    creatorHash: ReadonlyUint8Array;
    nonce: number | bigint;
    index: number;
    message: MetadataArgsArgs;
};
export declare function getVerifyCollectionInstructionDataEncoder(): Encoder<VerifyCollectionInstructionDataArgs>;
export declare function getVerifyCollectionInstructionDataDecoder(): Decoder<VerifyCollectionInstructionData>;
export declare function getVerifyCollectionInstructionDataCodec(): Codec<VerifyCollectionInstructionDataArgs, VerifyCollectionInstructionData>;
export type VerifyCollectionInput<TAccountTreeAuthority extends string = string, TAccountLeafOwner extends string = string, TAccountLeafDelegate extends string = string, TAccountMerkleTree extends string = string, TAccountPayer extends string = string, TAccountTreeDelegate extends string = string, TAccountCollectionAuthority extends string = string, TAccountCollectionAuthorityRecordPda extends string = string, TAccountCollectionMint extends string = string, TAccountCollectionMetadata extends string = string, TAccountEditionAccount extends string = string, TAccountBubblegumSigner extends string = string, TAccountLogWrapper extends string = string, TAccountCompressionProgram extends string = string, TAccountTokenMetadataProgram extends string = string, TAccountSystemProgram extends string = string> = {
    treeAuthority: Address<TAccountTreeAuthority>;
    leafOwner: Address<TAccountLeafOwner>;
    leafDelegate: Address<TAccountLeafDelegate>;
    merkleTree: Address<TAccountMerkleTree>;
    payer: TransactionSigner<TAccountPayer>;
    /**
     * This account is checked to be a signer in
     * the case of `set_and_verify_collection` where
     * we are actually changing the NFT metadata.
     */
    treeDelegate: Address<TAccountTreeDelegate>;
    collectionAuthority: TransactionSigner<TAccountCollectionAuthority>;
    /**
     * If there is no collecton authority record PDA then
     * this must be the Bubblegum program address.
     */
    collectionAuthorityRecordPda: Address<TAccountCollectionAuthorityRecordPda>;
    collectionMint: Address<TAccountCollectionMint>;
    collectionMetadata: Address<TAccountCollectionMetadata>;
    editionAccount: Address<TAccountEditionAccount>;
    bubblegumSigner: Address<TAccountBubblegumSigner>;
    logWrapper: Address<TAccountLogWrapper>;
    compressionProgram: Address<TAccountCompressionProgram>;
    tokenMetadataProgram?: Address<TAccountTokenMetadataProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    root: VerifyCollectionInstructionDataArgs['root'];
    dataHash: VerifyCollectionInstructionDataArgs['dataHash'];
    creatorHash: VerifyCollectionInstructionDataArgs['creatorHash'];
    nonce: VerifyCollectionInstructionDataArgs['nonce'];
    index: VerifyCollectionInstructionDataArgs['index'];
    message: VerifyCollectionInstructionDataArgs['message'];
};
export declare function getVerifyCollectionInstruction<TAccountTreeAuthority extends string, TAccountLeafOwner extends string, TAccountLeafDelegate extends string, TAccountMerkleTree extends string, TAccountPayer extends string, TAccountTreeDelegate extends string, TAccountCollectionAuthority extends string, TAccountCollectionAuthorityRecordPda extends string, TAccountCollectionMint extends string, TAccountCollectionMetadata extends string, TAccountEditionAccount extends string, TAccountBubblegumSigner extends string, TAccountLogWrapper extends string, TAccountCompressionProgram extends string, TAccountTokenMetadataProgram extends string, TAccountSystemProgram extends string>(input: VerifyCollectionInput<TAccountTreeAuthority, TAccountLeafOwner, TAccountLeafDelegate, TAccountMerkleTree, TAccountPayer, TAccountTreeDelegate, TAccountCollectionAuthority, TAccountCollectionAuthorityRecordPda, TAccountCollectionMint, TAccountCollectionMetadata, TAccountEditionAccount, TAccountBubblegumSigner, TAccountLogWrapper, TAccountCompressionProgram, TAccountTokenMetadataProgram, TAccountSystemProgram>): VerifyCollectionInstruction<typeof BUBBLEGUM_PROGRAM_ADDRESS, TAccountTreeAuthority, TAccountLeafOwner, TAccountLeafDelegate, TAccountMerkleTree, TAccountPayer, TAccountTreeDelegate, TAccountCollectionAuthority, TAccountCollectionAuthorityRecordPda, TAccountCollectionMint, TAccountCollectionMetadata, TAccountEditionAccount, TAccountBubblegumSigner, TAccountLogWrapper, TAccountCompressionProgram, TAccountTokenMetadataProgram, TAccountSystemProgram>;
export type ParsedVerifyCollectionInstruction<TProgram extends string = typeof BUBBLEGUM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        treeAuthority: TAccountMetas[0];
        leafOwner: TAccountMetas[1];
        leafDelegate: TAccountMetas[2];
        merkleTree: TAccountMetas[3];
        payer: TAccountMetas[4];
        /**
         * This account is checked to be a signer in
         * the case of `set_and_verify_collection` where
         * we are actually changing the NFT metadata.
         */
        treeDelegate: TAccountMetas[5];
        collectionAuthority: TAccountMetas[6];
        /**
         * If there is no collecton authority record PDA then
         * this must be the Bubblegum program address.
         */
        collectionAuthorityRecordPda: TAccountMetas[7];
        collectionMint: TAccountMetas[8];
        collectionMetadata: TAccountMetas[9];
        editionAccount: TAccountMetas[10];
        bubblegumSigner: TAccountMetas[11];
        logWrapper: TAccountMetas[12];
        compressionProgram: TAccountMetas[13];
        tokenMetadataProgram: TAccountMetas[14];
        systemProgram: TAccountMetas[15];
    };
    data: VerifyCollectionInstructionData;
};
export declare function parseVerifyCollectionInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedVerifyCollectionInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=verifyCollection.d.ts.map